//
// Created by postaron on 31/07/24.
//

#include "common_functions.hpp"
#include <iostream>
#include <format>

std::optional<std::ifstream> common::read_file(const std::filesystem::path &problemFile) noexcept {
    std::ifstream file(problemFile);
    if (!file.is_open()) {
        const auto error_state = file.rdstate();
        switch (error_state) {
            case std::ios::badbit:
                std::cerr << "Fatal I/O error occurred.\n";
                break;
            case std::ios::eofbit:
                std::cerr << "End of file reached.\n";
                break;
            case std::ios::failbit:
                std::cerr << "Non-fatal I/O error occurred.\n";
                break;
            default:
                std::cerr << "impossible to reach.\n";
                break;
        }
        const auto path_string = problemFile.string();
        const auto msg = std::format("Failed to open file {}: ", path_string);
        std::perror(msg.c_str());
        return std::nullopt;
    }
    return file;

}
